Index: /palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- /palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4539)
+++ /palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4540)
@@ -1,22 +1,21 @@
 !> @file biometeorology_mod.f90
-!--------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of PALM-4U.
 !
-! PALM-4U is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM-4U is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM-4U is free software: You can redistribute it and/or modify it under the terms of the GNU
+! General Public License as published by the Free Software Foundation, either version 3 of the
+! License, or (at your option) any later version.
+!
+! PALM-4U is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
+! the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 2018-2020 Deutscher Wetterdienst (DWD)
 ! Copyright 2018-2020 Institute of Computer Science, Academy of Sciences, Prague
 ! Copyright 2018-2020 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -27,89 +26,92 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
-! 
+!
 ! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO for reading local arrays
-! 
+!
 ! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
-! 
+!
 ! 4493 2020-04-10 09:49:43Z pavelkrc
 ! Revise bad formatting
-! 
+!
 ! 4286 2019-10-30 16:01:14Z resler
 ! implement new palm_date_time_mod
-! 
+!
 ! 4223 2019-09-10 09:20:47Z gronemeier
 ! Corrected "Former revisions" section
-! 
+!
 ! 4168 2019-08-16 13:50:17Z suehring
 ! Replace function get_topography_top_index by topo_top_ind
-! 
+!
 ! 4144 2019-08-06 09:11:47Z raasch
 ! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
-! 
+!
 ! 4127 2019-07-30 14:47:10Z suehring
 ! Output for bio_mrt added (merge from branch resler)
-! 
+!
 ! 4126 2019-07-30 11:09:11Z gronemeier
 ! renamed vitd3_exposure_av into vitd3_dose,
 ! renamed uvem_calc_exposure into bio_calculate_uv_exposure
-! 
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
-! of additional debug messages
-! 
+! Changes related to global restructuring of location messages and introduction of additional debug
+! messages
+!
 ! 3753 2019-02-19 14:48:54Z dom_dwd_user
-! - Added automatic setting of mrt_nlevels in case it was not part of 
-! radiation_parameters namelist (or set to 0 accidentially).
+! - Added automatic setting of mrt_nlevels in case it was not part of radiation_parameters namelist
+!   (or set to 0 accidentially).
 ! - Minor speed improvoemnts in perceived temperature calculations.
 ! - Perceived temperature regression arrays now declared as PARAMETERs.
-! 
+!
 ! 3750 2019-02-19 07:29:39Z dom_dwd_user
 ! - Added addittional safety meassures to bio_calculate_thermal_index_maps.
 ! - Replaced several REAL (un-)equality comparisons.
-! 
+!
 ! 3742 2019-02-14 11:25:22Z dom_dwd_user
-! - Allocation of the input _av grids was moved to the "sum" section of
-! bio_3d_data_averaging to make sure averaging is only done once!
-! - Moved call of bio_calculate_thermal_index_maps from biometeorology module to
-! time_integration to make sure averaged input is updated before calculating.
-! 
+! - Allocation of the input _av grids was moved to the "sum" section of bio_3d_data_averaging to
+!   make sure averaging is only done once!
+! - Moved call of bio_calculate_thermal_index_maps from biometeorology module to time_integration to
+!   make sure averaged input is updated before calculating.
+!
 ! 3740 2019-02-13 12:35:12Z dom_dwd_user
-! - Added safety-meassure to catch the case that 'bio_mrt_av' is stated after
-! 'bio_<index>' in the output section of the p3d file.
-! 
+! - Added safety-meassure to catch the case that 'bio_mrt_av' is stated after 'bio_<index>' in the
+!   output section of the p3d file.
+!
 ! 3739 2019-02-13 08:05:17Z dom_dwd_user
-! - Auto-adjusting thermal_comfort flag if not set by user, but thermal_indices
-! set as output quantities.
+! - Auto-adjusting thermal_comfort flag if not set by user, but thermal_indices set as output
+!   quantities.
 ! - Renamed flags "bio_<index>" to "do_calculate_<index>" for better readability
 ! - Removed everything related to "time_bio_results" as this is never used.
-! - Moved humidity warning to check_data_output
+! - Moved humidity warning to check_data_output.
 ! - Fixed bug in mrt calculation introduced with my commit yesterday.
-! 
+!
 ! 3735 2019-02-12 09:52:40Z dom_dwd_user
-! - Fixed auto-setting of thermal index calculation flags by output
-!  as originally proposed by resler.
+! - Fixed auto-setting of thermal index calculation flags by output as originally proposed by
+!   resler.
 ! - removed bio_pet and outher configuration variables.
 ! - Updated namelist.
-! 
+!
 ! 3711 2019-01-31 13:44:26Z knoop
 ! Introduced interface routine bio_init_checks + small error message changes
-! 
+!
 ! 3693 2019-01-23 15:20:53Z dom_dwd_user
-! Added usage of time_averaged mean radiant temperature, together with calculation, 
-! grid and restart routines. General cleanup and commenting.
-! 
+! Added usage of time_averaged mean radiant temperature, together with calculation, grid and restart
+! routines. General cleanup and commenting.
+!
 ! 3685 2019-01-21 01:02:11Z knoop
 ! Some interface calls moved to module_interface + cleanup
-! 
+!
 ! 3650 2019-01-04 13:01:33Z kanani
 ! Bugfixes and additions for enabling restarts with biometeorology
-! 
+!
 ! 3448 2018-10-29 18:14:31Z kanani
 ! Initial revision
 !
-! 
+!
 !
 ! Authors:
@@ -123,11 +125,11 @@
 ! ------------
 !> Biometeorology module consisting of two parts:
-!> 1.: Human thermal comfort module calculating thermal perception of a sample
-!> human being under the current meteorological conditions.
+!> 1.: Human thermal comfort module calculating thermal perception of a sample human being under the
+!> current meteorological conditions.
 !> 2.: Calculation of vitamin-D weighted UV exposure
 !>
 !> @todo Alphabetical sorting of "USE ..." lists, "ONLY" list, variable declarations
 !>       (per subroutine: first all CHARACTERs, then INTEGERs, LOGICALs, REALs, )
-!> @todo Comments start with capital letter --> "!-- Include..." 
+!> @todo Comments start with capital letter --> "!-- Include..."
 !> @todo uv_vitd3dose-->new output type necessary (cumulative)
 !> @todo consider upwelling radiation in UV
@@ -136,45 +138,44 @@
 !>
 !> @bug  no known bugs by now
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  MODULE biometeorology_mod
 
-    USE arrays_3d,                                                             &
+    USE arrays_3d,                                                                                 &
         ONLY:  pt, p, u, v, w, q
 
-    USE averaging,                                                             &
+    USE averaging,                                                                                 &
         ONLY:  pt_av, q_av, u_av, v_av, w_av
 
-    USE basic_constants_and_equations_mod,                                     &
-        ONLY:  c_p, degc_to_k, l_v, magnus, sigma_sb, pi
-
-    USE control_parameters,                                                    &
-        ONLY:  average_count_3d, biometeorology,                               &
-               debug_output,                                                   &
-               dz, dz_stretch_factor,                                          &
-               dz_stretch_level, humidity, initializing_actions, nz_do3d,      &
+    USE basic_constants_and_equations_mod,                                                         &
+        ONLY: degc_to_k, c_p, l_v, magnus, pi, sigma_sb
+
+    USE control_parameters,                                                                        &
+        ONLY:  average_count_3d, biometeorology,                                                   &
+               debug_output,                                                                       &
+               dz, dz_stretch_factor,                                                              &
+               dz_stretch_level, humidity, initializing_actions, nz_do3d,                          &
                restart_data_format_output, surface_pressure
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                                            &
         ONLY:  ddx, dx, ddy, dy
 
-    USE indices,                                                               &
-        ONLY:  nxl, nxr, nys, nyn, nzb, nzt, nys, nyn, nxl, nxr, nxlg, nxrg,   &
-               nysg, nyng, topo_top_ind
+    USE indices,                                                                                   &
+        ONLY:  nxl, nxr, nys, nyn, nzb, nzt, nys, nyn, nxl, nxr, nxlg, nxrg, nysg, nyng,           &
+               topo_top_ind
 
     USE kinds  !< Set precision of INTEGER and REAL arrays according to PALM
 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  netcdf_data_input_uvem, uvem_projarea_f, uvem_radiance_f,       &
-               uvem_irradiance_f, uvem_integration_f, building_obstruction_f
-
-    USE palm_date_time_mod,                                                    &
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY: building_obstruction_f, netcdf_data_input_uvem, uvem_integration_f,                  &
+              uvem_irradiance_f, uvem_projarea_f, uvem_radiance_f
+
+    USE palm_date_time_mod,                                                                        &
         ONLY:  get_date_time
 !
 !-- Import radiation model to obtain input for mean radiant temperature
-    USE radiation_model_mod,                                                   &
-        ONLY:  ix, iy, iz, id, mrt_nlevels, mrt_include_sw,                    &
-               mrtinsw, mrtinlw, mrtbl, nmrtbl, radiation,                     &
-               radiation_interactions, rad_sw_in,                              &
-               rad_sw_out, rad_lw_in, rad_lw_out
+    USE radiation_model_mod,                                                                       &
+        ONLY:  id, ix, iy, iz, mrt_include_sw, mrt_nlevels,                                        &
+               mrtbl, mrtinlw, mrtinsw, nmrtbl, radiation,                                         &
+               rad_lw_in, rad_lw_out, rad_sw_in, rad_sw_out, radiation_interactions
 
     USE restart_data_mpi_io_mod,                                                                   &
@@ -184,35 +185,15 @@
     IMPLICIT NONE
 
-    PRIVATE
-
 !
 !-- Declare all global variables within the module (alphabetical order)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tmrt_grid  !< tmrt results (degree_C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  perct      !< PT results   (degree_C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci       !< UTCI results (degree_C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet        !< PET results  (degree_C)
-!
-!-- Grids for averaged thermal indices
-    REAL(wp), DIMENSION(:), ALLOCATABLE   ::  mrt_av_grid   !< time average mean
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tmrt_av_grid  !< tmrt results (degree_C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  perct_av      !< PT results (aver. input)   (degree_C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci_av       !< UTCI results (aver. input) (degree_C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet_av        !< PET results (aver. input)  (degree_C)
-
-
-    INTEGER( iwp ) ::  bio_cell_level     !< cell level biom calculates for
-    REAL ( wp )    ::  bio_output_height  !< height output is calculated in m
-    REAL ( wp ), PARAMETER ::  human_absorb = 0.7_wp  !< SW absorbtivity of a human body (Fanger 1972)
-    REAL ( wp ), PARAMETER ::  human_emiss = 0.97_wp  !< LW emissivity of a human body after (Fanger 1972)
-    REAL ( wp ), PARAMETER ::  bio_fill_value = -9999._wp  !< set module fill value, replace by global fill value as soon as available
-!
-!--
-    LOGICAL ::  thermal_comfort  = .FALSE.  !< Enables or disables the entire thermal comfort part
-    LOGICAL ::  do_average_theta = .FALSE.  !< switch: do theta averaging in this module? (if .FALSE. this is done globally)
-    LOGICAL ::  do_average_q     = .FALSE.  !< switch: do e averaging in this module?
-    LOGICAL ::  do_average_u     = .FALSE.  !< switch: do u averaging in this module?
-    LOGICAL ::  do_average_v     = .FALSE.  !< switch: do v averaging in this module?
-    LOGICAL ::  do_average_w     = .FALSE.  !< switch: do w averaging in this module?
-    LOGICAL ::  do_average_mrt   = .FALSE.  !< switch: do mrt averaging in this module?
+    INTEGER(iwp) ::  bio_cell_level     !< cell level biom calculates for
+
+    LOGICAL ::  thermal_comfort        = .FALSE.  !< Enables or disables the entire thermal comfort part
+    LOGICAL ::  do_average_theta       = .FALSE.  !< switch: do theta averaging in this module? (if .FALSE. this is done globally)
+    LOGICAL ::  do_average_q           = .FALSE.  !< switch: do e averaging in this module?
+    LOGICAL ::  do_average_u           = .FALSE.  !< switch: do u averaging in this module?
+    LOGICAL ::  do_average_v           = .FALSE.  !< switch: do v averaging in this module?
+    LOGICAL ::  do_average_w           = .FALSE.  !< switch: do w averaging in this module?
+    LOGICAL ::  do_average_mrt         = .FALSE.  !< switch: do mrt averaging in this module?
     LOGICAL ::  average_trigger_perct  = .FALSE.  !< update averaged input on call to bio_perct?
     LOGICAL ::  average_trigger_utci   = .FALSE.  !< update averaged input on call to bio_utci?
@@ -227,18 +208,35 @@
     LOGICAL ::  do_calculate_mrt2d     = .FALSE.  !< Turn index MRT 2D (averaged or inst) on or off
 
+    REAL(wp)    ::  bio_output_height  !< height output is calculated in m
+
+    REAL(wp), PARAMETER ::  bio_fill_value = -9999.0_wp  !< set module fill value, replace by global fill value as soon as available
+    REAL(wp), PARAMETER ::  human_absorb = 0.7_wp  !< SW absorbtivity of a human body (Fanger 1972)
+    REAL(wp), PARAMETER ::  human_emiss = 0.97_wp  !< LW emissivity of a human body after (Fanger 1972)
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE   ::  mrt_av_grid   !< time average mean
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  perct      !< PT results   (degree_C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet        !< PET results  (degree_C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tmrt_grid  !< tmrt results (degree_C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci       !< UTCI results (degree_C)
+!
+!-- Grids for averaged thermal indices
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  perct_av      !< PT results (aver. input)   (degree_C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet_av        !< PET results (aver. input)  (degree_C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tmrt_av_grid  !< tmrt results (degree_C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci_av       !< UTCI results (aver. input) (degree_C)
+
 !
 !-- UVEM parameters from here
-!
-!-- Declare all global variables within the module (alphabetical order)
-    INTEGER(iwp) ::  bio_nmrtbl
     INTEGER(iwp) ::  ai                      = 0  !< loop index in azimuth direction
     INTEGER(iwp) ::  bi                      = 0  !< loop index of bit location within an 8bit-integer (one Byte)
+    INTEGER(iwp) ::  bio_nmrtbl
     INTEGER(iwp) ::  clothing                = 1  !< clothing (0=unclothed, 1=Arms,Hands,Face free, 3=Hand,Face free)
     INTEGER(iwp) ::  iq                      = 0  !< loop index of irradiance quantity
     INTEGER(iwp) ::  pobi                    = 0  !< loop index of the position of corresponding byte within ibset byte vektor
-    INTEGER(iwp) ::  obstruction_direct_beam = 0  !< Obstruction information for direct beam    
+    INTEGER(iwp) ::  obstruction_direct_beam = 0  !< Obstruction information for direct beam
     INTEGER(iwp) ::  zi                      = 0  !< loop index in zenith direction
 
-    INTEGER(KIND=1), DIMENSION(0:44)  ::  obstruction_temp1 = 0  !< temporary obstruction information stored with ibset 
+    INTEGER(KIND=1), DIMENSION(0:44)  ::  obstruction_temp1 = 0  !< temporary obstruction information stored with ibset
     INTEGER(iwp),    DIMENSION(0:359) ::  obstruction_temp2 = 0  !< restored temporary obstruction information from ibset file
 
@@ -251,6 +249,6 @@
 
     REAL(wp) ::  diffuse_exposure            =   0.0_wp  !< calculated exposure by diffuse radiation
-    REAL(wp) ::  direct_exposure             =   0.0_wp  !< calculated exposure by direct solar beam   
-    REAL(wp) ::  orientation_angle           =   0.0_wp  !< orientation of front/face of the human model    
+    REAL(wp) ::  direct_exposure             =   0.0_wp  !< calculated exposure by direct solar beam
+    REAL(wp) ::  orientation_angle           =   0.0_wp  !< orientation of front/face of the human model
     REAL(wp) ::  projection_area_direct_beam =   0.0_wp  !< projection area for direct solar beam
     REAL(wp) ::  saa                         = 180.0_wp  !< solar azimuth angle
@@ -261,5 +259,5 @@
     REAL(wp) ::  yfactor                     =   0.0_wp  !< relative y-position used for interpolation
 
-    REAL(wp), DIMENSION(0:2)  ::  irradiance =   0.0_wp  !< iradiance values extracted from irradiance lookup table  
+    REAL(wp), DIMENSION(0:2)  ::  irradiance =   0.0_wp  !< iradiance values extracted from irradiance lookup table
 
     REAL(wp), DIMENSION(0:2,0:90) ::  irradiance_lookup_table      = 0.0_wp  !< irradiance lookup table
@@ -269,5 +267,5 @@
     REAL(wp), DIMENSION(0:71,0:9) ::  projection_area_direct_temp  = 0.0_wp  !< temporary projection area for direct solar beam
     REAL(wp), DIMENSION(0:71,0:9) ::  projection_area_temp         = 0.0_wp  !< temporary projection area for all directions
-    REAL(wp), DIMENSION(0:35,0:9) ::  radiance_array               = 0.0_wp  !< radiance extracted from radiance_lookup_table  
+    REAL(wp), DIMENSION(0:35,0:9) ::  radiance_array               = 0.0_wp  !< radiance extracted from radiance_lookup_table
     REAL(wp), DIMENSION(0:71,0:9) ::  radiance_array_temp          = 0.0_wp  !< temporary radiance data
 
@@ -277,13 +275,14 @@
     REAL(wp), DIMENSION(0:35,0:9,0:90) ::  radiance_lookup_table   = 0.0_wp  !< radiance lookup table
 
+
+    PRIVATE
+
 !
 !-- INTERFACES that must be available to other modules (alphabetical order)
-
-    PUBLIC bio_3d_data_averaging, bio_check_data_output,                       &
-    bio_calculate_mrt_grid, bio_calculate_thermal_index_maps, bio_calc_ipt,    &
-    bio_check_parameters, bio_data_output_3d, bio_data_output_2d,              &
-    bio_define_netcdf_grid, bio_get_thermal_index_input_ij, bio_header,        &
-    bio_init, bio_init_checks, bio_parin, thermal_comfort,                     &
-    bio_nmrtbl, bio_wrd_local, bio_rrd_local, bio_wrd_global, bio_rrd_global
+    PUBLIC bio_3d_data_averaging,  bio_calculate_mrt_grid, bio_calculate_thermal_index_maps,       &
+           bio_calc_ipt, bio_check_data_output, bio_check_parameters,                              &
+           bio_data_output_2d, bio_data_output_3d,  bio_define_netcdf_grid,                        &
+           bio_get_thermal_index_input_ij, bio_header, bio_init, bio_init_checks, bio_nmrtbl,      &
+           bio_parin, bio_rrd_global, bio_rrd_local, bio_wrd_global, bio_wrd_local, thermal_comfort
 !
 !-- UVEM PUBLIC variables and methods
@@ -348,5 +347,5 @@
     END INTERFACE bio_header
 !
-!-- Initialization actions 
+!-- Initialization actions
     INTERFACE bio_init
        MODULE PROCEDURE bio_init
@@ -393,19 +392,17 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Sum up and time-average biom input quantities as well as allocate
-!> the array necessary for storing the average.
-!> There is a considerable difference to the 3d_data_averaging subroutines
-!> used by other modules:
-!> For the thermal indices, the module needs to average the input conditions
-!> not the result!
-!------------------------------------------------------------------------------!
+!> Sum up and time-average biom input quantities as well as allocate the array necessary for storing
+!> the average.
+!> There is a considerable difference to the 3d_data_averaging subroutines used by other modules:
+!> For the thermal indices, the module needs to average the input conditions, not the result!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE bio_3d_data_averaging( mode, variable )
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  mode     !< averaging mode: allocate, sum, or average
+    CHARACTER (LEN=*) ::  mode     !< Averaging mode: allocate, sum, or average
     CHARACTER (LEN=*) ::  variable !< The variable in question
 
@@ -425,5 +422,5 @@
                 ENDIF
                 mrt_av_grid = 0.0_wp
-                do_average_mrt = .FALSE.  !< overwrite if that was enabled somehow
+                do_average_mrt = .FALSE.  !< Overwrite if that was enabled somehow
 
 
@@ -431,17 +428,16 @@
 
 !
-!--          Averaging, as well as the allocation of the required grids must be
-!--          done only once, independent from for how many thermal indices 
-!--          averaged output is desired.
-!--          Therefore wee need to memorize which index is the one that controls
-!--          the averaging (what must be the first thermal index called).
-!--          Indices are in unknown order as depending on the input file,
-!--          determine first index to average und update only once
-!
-!--          Only proceed here if this was not done for any index before. This
-!--          is done only once during the whole model run.
-             IF ( .NOT. average_trigger_perct  .AND.                           &
-                  .NOT. average_trigger_utci   .AND.                           &
-                  .NOT. average_trigger_pet    .AND.                           &
+!--          Averaging, as well as the allocation of the required grids must be done only once,
+!--          independent of for how many thermal indices averaged output is desired.
+!--          Therefore we need to memorize which index is the one that controls the averaging
+!--          (what must be the first thermal index called).
+!--          Indices are in unknown order as depending on the input file, determine first index to
+!--          average und update only once.
+!
+!--          Only proceed here if this was not done for any index before. This is done only once
+!--          during the whole model run.
+             IF ( .NOT. average_trigger_perct  .AND.                                               &
+                  .NOT. average_trigger_utci   .AND.                                               &
+                  .NOT. average_trigger_pet    .AND.                                               &
                   .NOT. average_trigger_mrt )  THEN
 !
@@ -461,9 +457,9 @@
              ENDIF
 !
-!--          Allocation of the input _av grids was moved to the "sum" section to
-!--          make sure averaging is only done once!
-
+!--          Allocation of the input _av grids was moved to the "sum" section to make sure averaging
+!--          is only done once!
 
           CASE ( 'uvem_vitd3dose*' )
+
              IF ( .NOT. ALLOCATED( vitd3_dose ) )  THEN
                 ALLOCATE( vitd3_dose(nysg:nyng,nxlg:nxrg) )
@@ -482,18 +478,15 @@
           CASE ( 'bio_mrt' )
 !
-!--          Consider the case 'bio_mrt' is called after some thermal index. In 
-!--          that case do_average_mrt will be .TRUE. leading to a double-
-!--          averaging. 
+!--          Consider the case 'bio_mrt' is called after some thermal index. In that case
+!            do_average_mrt will be .TRUE. leading to a double-averaging.
              IF ( .NOT. do_average_mrt  .AND.  ALLOCATED( mrt_av_grid ) )  THEN
 
                 IF ( mrt_include_sw )  THEN
-                   mrt_av_grid(:) = mrt_av_grid(:) +                           &
-                      ( ( human_absorb * mrtinsw(:) +                          &
-                      mrtinlw(:) ) /                                           &
-                      ( human_emiss * sigma_sb ) )**.25_wp - degc_to_k
+                   mrt_av_grid(:) = mrt_av_grid(:)  +                                              &
+                                    ( ( human_absorb * mrtinsw(:) +                                &
+                                    mrtinlw(:) ) / ( human_emiss * sigma_sb ) )**.25_wp - degc_to_k
                 ELSE
-                   mrt_av_grid(:) = mrt_av_grid(:) +                           &
-                      ( mrtinlw(:) /                                           &
-                      ( human_emiss * sigma_sb ) )**.25_wp - degc_to_k
+                   mrt_av_grid(:) = mrt_av_grid(:) +                                               &
+                                    ( mrtinlw(:) / ( human_emiss * sigma_sb ) )**.25_wp - degc_to_k
                 ENDIF
              ENDIF
@@ -501,18 +494,13 @@
           CASE ( 'bio_perct*', 'bio_utci*', 'bio_pet*', 'bio_mrt*' )
 !
-!--          Only continue if the current index is the one to trigger the input 
-!--          averaging, see above
-             IF ( average_trigger_perct  .AND.  TRIM( variable ) /=            &
-                'bio_perct*')  RETURN
-             IF ( average_trigger_utci   .AND.  TRIM( variable ) /=            &
-                'bio_utci*')   RETURN
-             IF ( average_trigger_pet    .AND.  TRIM( variable ) /=            &
-                'bio_pet*')    RETURN
-             IF ( average_trigger_mrt    .AND.  TRIM( variable ) /=            &
-                'bio_mrt*')    RETURN
-!
-!--          Now memorize which of the input grids are not averaged by other 
-!--          modules. Set averaging switch to .TRUE. and allocate the respective
-!--          grid in that case.
+!--          Only continue if the current index is the one to trigger the input averaging, see
+!--          above.
+             IF ( average_trigger_perct  .AND.  TRIM( variable ) /= 'bio_perct*')    RETURN
+             IF ( average_trigger_utci   .AND.  TRIM( variable ) /= 'bio_utci*' )    RETURN
+             IF ( average_trigger_pet    .AND.  TRIM( variable ) /= 'bio_pet*'  )    RETURN
+             IF ( average_trigger_mrt    .AND.  TRIM( variable ) /= 'bio_mrt*'  )    RETURN
+!
+!--          Now memorize which of the input grids are not averaged by other modules. Set averaging
+!--          switch to .TRUE. and allocate the respective grid in that case.
              IF ( .NOT. ALLOCATED( pt_av ) )  THEN  !< if not averaged by other module
                 ALLOCATE( pt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
@@ -546,5 +534,5 @@
 
 !
-!-- u_av, v_av and w_av are always allocated
+!--          u_av, v_av and w_av are always allocated
              IF ( .NOT. ALLOCATED( u_av ) )  THEN
                 ALLOCATE( u_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
@@ -600,12 +588,12 @@
 
                 IF ( mrt_include_sw )  THEN
-                   mrt_av_grid(:) = mrt_av_grid(:) +                           &
-                      ( ( human_absorb * mrtinsw(:) +                          &
-                      mrtinlw(:) ) /                                           &
-                      ( human_emiss * sigma_sb ) )**.25_wp - degc_to_k
-                ELSE
-                   mrt_av_grid(:) = mrt_av_grid(:) +                           &
-                      ( mrtinlw(:) /                                           &
-                      ( human_emiss * sigma_sb ) )**.25_wp - degc_to_k
+                   mrt_av_grid(:) = mrt_av_grid(:) +                                               &
+                                    ( ( human_absorb * mrtinsw(:) +                                &
+                                    mrtinlw(:) ) /                                                 &
+                                      ( human_emiss  * sigma_sb ) )**0.25_wp - degc_to_k
+               ELSE
+                   mrt_av_grid(:) = mrt_av_grid(:) +                                               &
+                                    ( mrtinlw(:) /                                                 &
+                                    ( human_emiss * sigma_sb ) )**0.25_wp - degc_to_k
                 ENDIF
              ENDIF
@@ -632,7 +620,6 @@
           CASE ( 'bio_mrt' )
 !
-!--          Consider the case 'bio_mrt' is called after some thermal index. In 
-!--          that case do_average_mrt will be .TRUE. leading to a double-
-!--          averaging. 
+!--          Consider the case 'bio_mrt' is called after some thermal index. In that case
+!--          do_average_mrt will be .TRUE. leading to a double-averaging.
              IF ( .NOT. do_average_mrt  .AND.  ALLOCATED( mrt_av_grid ) )  THEN
                 mrt_av_grid(:) = mrt_av_grid(:) / REAL( average_count_3d, KIND=wp )
@@ -642,11 +629,11 @@
 !
 !--          Only continue if update index, see above
-             IF ( average_trigger_perct  .AND.                                 &
+             IF ( average_trigger_perct  .AND.                                                     &
                 TRIM( variable ) /= 'bio_perct*' )  RETURN
-             IF ( average_trigger_utci  .AND.                                  &
+             IF ( average_trigger_utci  .AND.                                                      &
                 TRIM( variable ) /= 'bio_utci*' )  RETURN
-             IF ( average_trigger_pet   .AND.                                  &
+             IF ( average_trigger_pet   .AND.                                                      &
                 TRIM( variable ) /= 'bio_pet*' )  RETURN
-             IF ( average_trigger_mrt   .AND.                                  &
+             IF ( average_trigger_mrt   .AND.                                                      &
                 TRIM( variable ) /= 'bio_mrt*' )  RETURN
 
